$j(document).ready(function() {        
    
	window.verifyKeyAndIncludeSelection = function() {
		var iflag = false;
		var kflag = false;
                
                var qSourceFieldErrorSpan = "#sourcefield_error";
                var qSourceFieldSpan = window.getSourceFieldSpanQuery();                
                
                if ($j.trim(qSourceFieldSpan).length > 0)
                {
                    
                    // Evaluate first the number of fields inside current source field
                    var fields_count = getKeyElements(qSourceFieldSpan).length;
                    
                    var selection_code = ($j('input.source-keybox:checked').filter(':visible').length > 0 ? 3 : 0) + ($j('input.source-includebox:checked').filter(':visible').length > 0 ? 2 : 0);
                    // `selection_code` value
                    // 5 = has both key and include fields
                    // 3 = there's only key field
                    // 2 = there's only include field
                    
                    if (fields_count == 1 && [ 3, 2 ].contains(selection_code))
                    {
                        return true;
                    }
                    else
                    {
                        switch (selection_code)
                        {
                            case 3:
                            {
                                // No include field selected
                                var message = 'You didn\'t select any source field as INCLUDE field';
                                $j('#sourcefield_error').show().html('<b>Error:</b> ' + message);
                                alert(message);
                                return false;
                            }
                            case 0:
                            case 2:
                            {
                                // No key field selected
                                var message = "You didn't select any source field as KEY field(s)";
                                $j('#sourcefield_error').show().html('<b>Error:</b> ' + message);
                                alert(message);
                                return false;
                            }
                        }
                    }
                }
                else
                {
                    alert("An invalid config type has been added. This needs to be updated.\nContact Open iT for more information.");
                    return false;
                }
                
                $j(qSourceFieldErrorSpan).html('').hide();
                
                return true;
	}
    
    
        if (!window.getKeyElements)
        {
            /**
             * Get DOM "input" elements representing KEY fields
             * 
             * @param {string} $qSourceFieldSpan
             * @param {boolean=false} $selectedOnly
             * @returns {array} Array of matching jQuery DOM elements
             */
            window.getKeyElements = function($qSourceFieldSpan, $selectedOnly)
            {
                if (!$selectedOnly)
                    $selectedOnly = false;
                
                return $j($qSourceFieldSpan + " input[type=checkbox].source-keybox" + ($selectedOnly ? ":checked" : "")).filter(':not([disabled])');
            };
        }
        
        
        if (!window.getIncludeElements)
        {
            /**
             * Get DOM "input" elements representing INCLUDE fields
             * 
             * @param {string} $qSourceFieldSpan
             * @param {boolean=false} $selectedOnly
             * @returns {array} Array of matching jQuery DOM elements
             */
            window.getIncludeElements = function($qSourceFieldSpan, $selectedOnly)
            {
                if (!$selectedOnly)
                    $selectedOnly = false;
                
                var inputType = $qSourceFieldSpan.search(/single(.*)$/i) >= 0 ? "radio" : "checkbox";
                    
                return $j($qSourceFieldSpan + "input[type=" + inputType + "].source-includebox" + ($selectedOnly ? ":checked" : "")).filter(':not([disabled])');
            };
        }
        
        
        if (!window.getSourceFieldSpanQuery)
        {
            /**
             * Get source field span query string based on Map type drop-down element
             * 
             * @returns {String|null}
             */
            window.getSourceFieldSpanQuery = function()
            {
                var result = null;
                var configType = parseInt($j('select#maptypeid').val());

                switch (configType)
                {
                    case 1: // virtual
                    case 2: // license-single
                    {
                        result = "span#sourceFieldsSingle";
                        break;
                    }
                    case 3: // license-multi
                    {
                        result = "span#sourceFieldsMulti";
                        break;
                    }
                }
                
                return result;
            }
        }
        
        
        if (!window.submitFormAndRefresh)
        {
            /**
             * Submit current form and refresh
             * 
             * @param {boolean} $bypass_validation (Optional) If bypass validation
             */
            window.submitFormAndRefresh = function($bypass_validation)
            {
                if ($bypass_validation == undefined)
                    $bypass_validation = false;
                
                var qForm = 'form#mappingform';
                var qControls = 'input';
                
                if (!$bypass_validation && !window.verifyKeyAndIncludeSelection())
                    return;
                
                $j.ajax({
                    url: $j(qForm).attr('action'),
                    data: $j(qForm).serialize(),
                    type: 'post',
                    beforeSend: function()
                    {
                        $j(qForm + ' ' + qControls).attr('disabled', 'disabled');
                    },
                    success: function()
                    {
                        window.location.reload();
                    },
                    error: function(jqXHR, textStatus, errorThrown)
                    {
                        alert(textStatus + ": " + errorThrown);
                        $j(qForm + ' ' + qControls).removeAttr('disabled');
                    }
                });
            }
        }
        
        
    
        // Let's add listener when user (un)checks a mapping source
        // only in EDIT mode
        
        if (!window.isCreateMode)
        {
            $j('input[type=checkbox].checkbox-mappingsource').click(function(e)
            {
                var mappingsource_id = $j(e.target).val();
                var is_checked = $j(e.target).is(':checked');

                var qMulti_boxes = '#mdata' + mappingsource_id + ' input[type=checkbox], #mdata' + mappingsource_id + ' input[type=radio]';
                var qSingle_boxes = '#data' + mappingsource_id + ' input[type=checkbox], #data' + mappingsource_id + ' input[type=radio]';

                // Check if user is trying to add new mapping source
                if (!window.getCurrentMappingSourceIDs().contains(mappingsource_id))
                {
                    // if yes, submit this form and refresh
                    window.submitFormAndRefresh(true);
                }

                if (is_checked)
                {
                    $j(qSingle_boxes).removeAttr('disabled');
                    $j(qMulti_boxes).removeAttr('disabled');
                    return;
                }
                $j(qSingle_boxes).removeAttr('checked').attr('disabled', 'disabled');
                $j(qMulti_boxes).removeAttr('checked').attr('disabled', 'disabled');
            });


            // Check first if there's only one field
            var allow_submission = window.getKeyElements(getSourceFieldSpanQuery()).length > 1 ? true 
                    // otherwise, check if user is just trying to add another mapping source
                    : ($j('input[type=checkbox].checkbox-mappingsource:checked').length > $j('input[type=checkbox].checkbox-mappingsource[checked]').length);

            if (!allow_submission)
            {
                var message = "This mapping config cannot be saved with only one (1) field defined from selected mapping source.";
                $j('form#mappingform input[type=submit]').attr('disabled', 'disabled');
                alert(message);
                $j('span#sourcefield_error').html(message).show();
            }
            
        }



//    $j('form[name=mapping]').on("submit", function(e) {
//
//        if (!verifyKeyAndIncludeSelection(e.target))
//            e.preventDefault();
//
//    });



});